const request = require('request');
const crypto = require('crypto');

const config = {
    url: 'https://live.moduyun.com/directmail/v1/singleSendMail',
    accesskey: '',  // 根据实际填 accesskey
    secretkey: '',  // 根据实际填 secretkey
};

let MailSender = {
    getRandom(lower = 100000, upper = 999999) {
        return Math.floor(Math.random() * (upper - lower)) + lower;
    },
    sig(fromEmail, random, curTime) {
        let hash = crypto.createHash('sha256');

        hash.update('secretkey='+config.secretkey+
                    '&random='+random+
                    '&time='+curTime+
                    '&fromEmail='+fromEmail);

        return hash.digest('hex').toUpperCase();
    },
    send(fromEmail, toEmail, subject, htmlBody) {
        let self = this;

        let curTime = Math.floor(Date.now()/1000);
        let random = self.getRandom();

        let data = {
            sig: self.sig(fromEmail, random, curTime),
            ext: '',
            replyEmail: '',
            fromAlias: '',
            htmlBody: htmlBody,
            needToReply: false,
            subject: subject,
            clickTrace: '0',
            readTrace: '0',
            time: curTime,
            type: 0,
            toEmail: toEmail,
            fromEmail: fromEmail
        };

        request({
            url: config.url+'?accesskey='+config.accesskey+'&random='+random,
            method: 'POST',
            json: data
        }, (err, res, body) => {
            if (err) {
                console.log(err);
                return;
            }
            console.log(body);
        });
    },
    test() {
        let code = this.getRandom();

        // 根据实际调用 send(fromEmail, toEmail, subject, htmlBody) 
        this.send('xxxx@system.xxx.com', 'xx@xx.com', '您的验证码', '您的验证码是：'+code);

        console.log('xxx@xxx.com 的验证码是：'+code);
    }
};

MailSender.test();

module.exports = MailSender;
